<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/


function print_array($a) {
	echo "<pre>";
	print_r($a);
	echo "</pre>";
}

// Use this to centralise how we hash passes
function crypt_password($pass) {

	// Generate "random" string
	$fp = fopen('/dev/urandom', 'r');
	$random = fread($fp, 32);
	fclose($fp);

	//mcrypt_create_iv() ?? generate salt ?

	//Base 64 encode to ensure that some characters will not cause problems for crypt
	$salt = base64_encode($random);

	// Crypt password with salt - http://php.net/crypt
	$encpass = crypt($pass, '$6$'.$salt);

	// Add algo prefix - SHA512-CRYPT for now
	$encpass = "{SHA512-CRYPT}".$encpass;

	return $encpass;
}

/* permission functions */
function am_i_admin() {
	//if ($_SESSION['login']['admin'] OR $_SESSION['login']['admin_of']) { // TODO/FIXME make sure this doesn't break stuff
	if ($_SESSION['login']['admin']) {
		return true;
	}
}
function am_i_admin_of_anything() {
	if ($_SESSION['login']['admin'] OR $_SESSION['login']['admin_of']) {
		return true;
	}
}
function am_i_server_admin($level="10000") {
	global $cfg;
	if ((am_i_admin_of_anything() AND $level <= $cfg['privacy_level']) OR ($_SESSION['login']['admin'])) {
		return true;
	}
}
function am_i_user() {
	if ($_SESSION['login']['user']) {
		return true;
	}
}
function am_i_admin_of($domain_id) {
	if ((is_array($_SESSION['login']['admin_of']) AND array_key_exists($domain_id, $_SESSION['login']['admin_of'])) OR ($_SESSION['login']['admin'])) {
		return true;
	}
}
function is_this_mine($uid) {
	if ($_SESSION['login']['uid'] == $uid) {
		return true;
	}
}
function list_my_domains() {
	if (!am_i_server_admin(1)) {
		$not_server_admin_q = "WHERE id IN(";
		if (is_array($_SESSION['login']['admin_of'])) {
			foreach ($_SESSION['login']['admin_of'] as $k => $v) {
				$not_server_admin_q .= "$k,";
			}
			$not_server_admin_q = rtrim($not_server_admin_q, ',');
		} else {
			$not_server_admin_q .= $_SESSION['login']['domain_id'];
		}
		$not_server_admin_q .= ")";
	}
	return $not_server_admin_q;
}
function domain_can_ml($domain_id) {
	// return true if we are allowed AND configured to use MLs
	global $cfg;
	global $cnx;
	$domain_ml = $cnx->select_field("ml", "virtual_domains", "WHERE `id` ='$domain_id'");
	if ($domain_ml AND $cfg['ml']) {
		return true;
	} else {
		return false;
	}
}

function four_o_four() {
	$link = genlink("page=404");
	//following is for non pretty urls for some reason
	$link = str_replace("&amp;", "&", $link);
	header("HTTP/1.0 404 Not Found");
	header('Refresh: 0; url='.$link.'');
	exit();
}

function fill_check_input($var, $type, $value="oisfosd#foo") {
	if (isset($var)) {
		if ($type == "input") { echo $var; }
		if ($type == "check") { if ($var == $value) { echo 'checked="checked"'; }	}
		if ($type == "select") { if ($var == $value) { echo 'selected="selected"'; }	}
		if ($type == "mselect") { foreach ($var as $opt) { if ($opt == "$value") { echo 'selected="selected"'; } } }
		if ($type == "mcheck") { foreach ($var as $opt) { if ($opt == "$value") { echo 'checked="checked"'; } } }
	}
}

// Check for listing order
function check_order_by($type) {
	global $page;
	$type_array = array (
			'domains' => array ('id', 'name', 'default_policy', 'policy_name', 'policy_id', 'default_quota', 'default_mail', 'default_xmpp', 'accounts', 'aliases'),
			'accounts' => array ('uid', 'user', 'email', 'quota_kb', 'mail', 'xmpp', 'policy_name', 'admin', 'admin_of_ids', 'admin_of_names', 'suspend'),
			'aliases' => array ('source', 'destination'),
			'policies' => array ('id', 'policy_name', 'virus_lover', 'spam_lover', 'banned_files_lover', 'bad_header_lover', 'bypass_virus_checks',
			'bypass_spam_checks', 'bypass_banned_checks', 'bypass_header_checks', 'spam_modifies_subj', 'spam_quarantine_to', 'spam_tag_level',
			'spam_tag2_level', 'spam_kill_level'),
			'relay_domains' => array ('id', 'domain', 'note'),
			'ip_access' => array ('id', 'ip', 'state', 'note'),
			'domain_access' => array ('id', 'domain', 'state', 'note'),
	);
	$order_array = array('DESC', 'ASC');
	$order_by_array = $type_array[$type];
	$order_desc_asc = strtoupper($_GET['order']);
	$order_by_this = $_GET['order_by'];
	if (empty($order_desc_asc) OR !in_array($order_desc_asc, $order_array)) {
		$order_desc_asc = "ASC";
		$ascdesc = "DESC";
	} elseif ($order_desc_asc == "DESC") {
		$ascdesc = "ASC";
	} else {
		$ascdesc = "DESC";
	}
	foreach ($order_by_array as $k => $v) {
		if ($_GET['page'] == "accounts") {
			$result['th'][$v] = genlink("page=accounts|domain_id=".$_GET['domain_id']."|order_by=$v|order=$ascdesc");
		} else {
			$result['th'][$v] = genlink("page=$page|order_by=$v|order=$ascdesc");
		}
	}
	if (empty($order_by_this) OR !in_array($order_by_this, $order_by_array)) {
		$order_by_this = "";
	}
	if (!empty($order_by_this)) {
		$result['order_by'] = "ORDER BY $order_by_this $order_desc_asc";
	}
	return $result;
}

function genlink($var="") {
	global $cfg;

	if ($cfg['prettyurls']) {
		$url = $cfg['siteroot']."/";
	} else {
		$url = $cfg['siteroot']."/index.php?";
	}

	$link = explode('|', $var);
	foreach ($link as $k => $v) {
		$lol = explode('=', $v);
		if ($cfg['prettyurls']) {
			if ($lol[0] == "page" OR $lol[0] == "permlink" ) {
				$url .= $lol[1]."/";
			} else {
				$url .= $lol[0]."/".$lol[1]."/";
			}
		} else {
			if ($k > 0) {
				//$url .= "&amp;".$lol[0]."=".$lol[1];
				$url .= "&".$lol[0]."=".$lol[1];
			} else {
				$url .= $lol[0]."=".$lol[1];
			}
		}
	}

	if ($cfg['prettyurls']) {
		$url = rtrim($url, "/");
	} else {
		$url = rtrim($url, "=");
		$url = rtrim($url, "?");
		$url = preg_replace("#&amp;$#", '', "$url");
	}

	$url = str_replace(' ', '%20', $url);
	return $url;
}

// Various tests
function is_valid_id($number) {
	if (preg_match("#^[0-9]{1,}$#", $number)) {
		return true;
	} else {
		return false;
	}
}

// Put errors and status into content from within a function, object, etc.
function set_status($msg) {
	global $content;
	$content['status'][] = $msg;
}
function set_error($msg) {
	global $content;
	$content['errors'][] = $msg;
}

?>
