<?php

// Version 1.2.5

class MysqlThing {

	function __construct($db_host, $db_user, $db_pass, $db_name) {

		// TODO make sure this will always work - OBSOLETE
		global $sql_locale;

		$this->c = mysqli_connect($db_host, $db_user, $db_pass);
		if (!$this->c) {
			echo "cannot connect to db";
			exit();
		}
		if (mysqli_error($this->c)) {
			echo "cannot connect to db";
			exit();
		}
		mysqli_select_db($this->c, $db_name);
		if (mysqli_error($this->c)) {
			echo "Cannot find database";
			exit();
		}
		mysqli_query($this->c, "SET CHARACTER SET 'utf8'");
		mysqli_query($this->c, "SET character_set_results = NULL");
		mysqli_query($this->c, "SET group_concat_max_len = 10240;");

		// For clean dates and such
		mysqli_query($this->c, "SET NAMES 'utf8';");
		// TODO remove this one day
		mysqli_query($this->c, "SET lc_time_names='$sql_locale';");
	}

	function set_locale($locale) {
		mysqli_query($this->c, "SET lc_time_names='$locale';");
	}

	// TODO s/select/query/  (later on create a "select" function that takes 1.array 2.table (like with insert))
	function query($query, $a=1) {
		// Simple function to just get an array in return of a mysql query
		$q = mysqli_query($this->c, $query);

		if ($q AND $a) {
			while ($data = mysqli_fetch_assoc($q)) {
				// TODO - add stripslashes and stuff like that ?
				$result[] = $data;
			}
			return $result;
		} else {
			return true;
		}
	}


	// TODO figure out the best way for order, where etc (complexe selects on multiple tables ?)
	//function select($array, $table, $order="", $where="") {
	function select($array, $table, $addon="") {
		$array_check = $this->explain($table);

		if (!is_array($array_check)) {
			return false;
		}
		//print_array($array_check, "ARRAY CHECK");
		//print_array($array, "ARRAY");
		//echo "AR = $array";

		if ($array == "*") {
			unset($array);
			$array = $array_check;
		} if (!is_array($array)) {
			$tmp_array = explode(",", $array);
			unset($array);
			foreach ($tmp_array as $v) {
				$array[] = trim($v);
			}
		}

		if (is_array($array)) {
			$select_me = "";
			foreach ($array as $k) {
				if (in_array($k, $array_check)) {
					$select_me .= "`$k`, ";
				}
			}
			$select_me = rtrim($select_me, ", ");
			$q = mysqli_query($this->c, "SELECT $select_me FROM `$table` $addon;");
			//echo "<pre>SELECT $select_me FROM `$table` $addon;</pre>";
			if ($q) {
				while ($data = mysqli_fetch_assoc($q)) {
					// TODO - add stripslashes and stuff like that ?
					//$result[] = $data;

					$tmp_ar = array();
					foreach ($data as $k => $v) {
						$tmp_ar[$k] = stripslashes($v);
					}
					$result[] = $tmp_ar;
				}
			}
			if (isset($result)) {
				return $result;
			}
		}
	}

	function select_row($array, $table, $addon="") {
		$r = $this->select($array, $table, $addon);
		$r = $this->de_dimension($r);
		return $r;
	}

	function select_row2($array, $table, $addon="") {
		$r = $this->select($array, $table, $addon);
		$r = $this->de_dimension($r, 1);
		return $r;
	}

	function select_field($array, $table, $addon="") {
		$r = $this->select($array, $table, $addon);
		$r = $this->de_dimension($r, 1);
		$r = $r[0];
		return $r;
	}

	function de_dimension($array, $field=0) {
		if (is_array($array)) {
			foreach ($array as $k => $v) {
				if (is_array($v)) {
					foreach ($v as $k2 => $v2) {
						if ($field) {
							$new_array[] = $v2;
						} else {
							$new_array[$k2] = $v2;
						}
					}
				}
			}
		}
		if (isset($new_array)) {
			return $new_array;
		}
	}

	function escape($var) {
		$var = trim($var);
		$var = mysqli_real_escape_string($this->c, $var);
		return $var;
	}

	function delete($id, $table, $field="id") {
		if (is_valid_id($id)) {
			mysqli_query($this->c, "DELETE FROM `$table` WHERE `$field` ='$id';");
			// Return qty of rows affected (0 = nothing)
			return mysqli_affected_rows($this->c);
		}
	}

	function explain($table){
		$table_struct = $this->query("EXPLAIN $table");
		if (is_array($table_struct)) {
			foreach ($table_struct as $k => $v) {
				$array_check[] = $v['Field'];
			}
			return $array_check;
		}
	}

	function insert($array, $table) {
		$array_check = $this->explain($table);
		if (is_array($array) AND is_array($array_check)) {
			foreach ($array as $k => $v) {
				if (in_array($k, $array_check)) {
					if (is_null($v)) {
						$keys .= "`$k`, ";
						$vals .= "NULL, ";
					} else {
						$v = $this->escape($v);
						$keys .= "`$k`, ";
						$vals .= "'$v', ";
					}
				}
			}
			$keys = rtrim($keys, ", ");
			$vals = rtrim($vals, ", ");
			// echo "<pre>INSERT INTO `$table` ($keys) VALUES ($vals);</pre>";
			mysqli_query($this->c, "INSERT INTO `$table` ($keys) VALUES ($vals);");

			if (mysqli_error($this->c)) {
				return mysqli_error($this->c);
			} else {
				if (mysqli_insert_id($this->c)) {
					return mysqli_insert_id($this->c);
				} else {
					return true;
				}
			}
		}
	}

	// TODO add $id and/or $where
	function update($array, $table, $id) {
		$array_check = $this->explain($table);
		if (is_array($array)) {
			foreach ($array as $k => $v) {
				if (in_array($k, $array_check)) {
					if (is_null($v)) {
						$inserts .= "`$k` = NULL, ";
					} else {
						$v = $this->escape($v);
						$inserts .= "`$k` = '$v', ";
					}
				}
			}
			$inserts = rtrim($inserts, ", ");
			mysqli_query($this->c, "UPDATE `$table` SET $inserts WHERE `id` = $id;");
			//echo "<pre>UPDATE `$table` SET $inserts WHERE `id` = $id;</pre>";
			if (!mysqli_error($this->c)) {
				return 1;
			}
		}
	}

	function table_exists($table) {
		$q = mysqli_query($this->c, "SELECT * FROM `$table` LIMIT 1;");
		if ($q) {
			return true;
		}
	}

	function field_exists($field, $table) {
		$q = mysqli_query($this->c, "SELECT $field FROM `$table` LIMIT 1;");
		if ($q) {
			return true;
		}
	}

	function __destruct() {
		if ($this->c) {
			mysqli_close($this->c);
		}
	}

}

?>
