USE `mailboy`;

/*	Mailboy User (read-only user for Postix, Amavis, Ejabberd, etc
	REPLACE mailuser_password with an actual password */
GRANT SELECT ON mailboy.* TO mailuser@localhost IDENTIFIED BY 'mailuser_password';

/*	Mailboy Admin (read-write user, for Mailboy admin interface
	REPLACE mailuser_password with an actual password */
GRANT SELECT, INSERT, UPDATE, DELETE, CREATE, DROP, INDEX, ALTER,
CREATE TEMPORARY TABLES, CREATE VIEW, SHOW VIEW, CREATE ROUTINE,
ALTER ROUTINE, EXECUTE ON mailboy.* TO 'mailadmin'@'localhost' IDENTIFIED BY 'mailadmin_password';

FLUSH PRIVILEGES;

/*	Add a master user account
	EXAMPLE for bob@example.org
	REPLACE example.org with your domain name
	REPLACE bob with your user name (email prefix)
	REPLACE bobs_password with an actual password for this user */
INSERT INTO virtual_domains (id, name) VALUES (1, 'example.org');
INSERT INTO virtual_users (id, domain_id, user, password, xmpp, admin) VALUES (1, 1, 'bob', CONCAT("{SHA512-CRYPT}", ENCRYPT('bobs_password', '$6$')), 1, 1);
