<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/

function account_switch($error="") {
	$uid = $_SESSION['login']['uid'];
	if ($error) {
		$_SESSION['errors']['account_details'][] = "Incorrect user ID. Switching to your account";
	}
	$redirect_link = genlink("page=account_details|uid=$uid");
	header("Location: $redirect_link");
}


// get error/status from _session TODO move this to index.php
if ($_SESSION['status']['account_details']) {
	foreach ($_SESSION['status']['account_details'] as $k => $v) {
		$content['status'][] = $v;
	}
	unset($_SESSION['status']['account_details']);
}
if (isset($_SESSION['errors']['account_details'])) {
	foreach ($_SESSION['errors']['account_details'] as $k => $v) {
		$content['errors'][] = $v;
	}
	unset($_SESSION['errors']['account_details']);
}


// Get useful IDs
// check user/alias id and set it to something that works if needed
if ($_GET['uid']) {
	$uid = $_GET['uid'];
	if (!is_valid_id($uid)) {
		account_switch(1);
	} else {
		$domain_id = $cnx->select_field("domain_id", "virtual_users", "WHERE `id` = '$uid'");
		if ( (!am_i_admin_of($domain_id) AND !is_this_mine($uid)) OR empty($domain_id)  ) {
			account_switch(1);
		}
	}
	// We now have $uid and $domain_id

} elseif ($_GET['alias_id']) {
	$alias_id = $_GET['alias_id'];
	if (!is_valid_id($alias_id)) {
		account_switch(1);
	} else {
		$domain_id = $cnx->select_field("domain_id", "virtual_aliases", "WHERE `id` = '$alias_id'");
		if (empty($domain_id) OR !am_i_admin_of($domain_id)) {
			account_switch(1);
		}
	}
	// We now have $alias_id and $domain_id

} elseif ($_GET['ml_id']) {
	// Do some ML stuff !
	$ml_id = $_GET['ml_id'];
	if (!is_valid_id($ml_id)) {
		account_switch(1);
	} else {
		$domain_id = $cnx->select_field("domain_id", "virtual_mailing_lists", "WHERE `id` = '$ml_id'");
		if (empty($domain_id) OR !am_i_admin_of($domain_id)) {
			account_switch(1);
		}
	}
	// We now have $ml_id and $domain_id

} else if ($_POST['id']) {
	$uid = $_POST['id'];
} else {
	// Catchall
	account_switch();
}


if ($uid) {

	// Display details
	$content['account_details']['details'] = $cnx->select_row("*", "view_users", "WHERE `uid` = '$uid'");
	unset($content['account_details']['details']['password']);
	$edit_account_form = new FormMaker("edit_account", genlink("page=account_details|uid=$uid"));

	// User
	$edit_account_form->add_element("user", "text", "free|127", 1);
	$edit_account_form->set_display_name("user", "User");
	$edit_account_form->add_input_desc("user", "@".$content['account_details']['details']['domain']);

	$edit_account_form->add_element("id", "hidden", "custom|#^$uid$#", 1);
	$edit_account_form->set_value("id", $uid);

	if (am_i_server_admin() OR !$content['account_details']['details']['admin']) {
		// Password
		$edit_account_form->add_element("password", "password", "free|127");
		$edit_account_form->set_display_name("password", "Password");
	}


	// Policies
	$policies_array = $cnx->select(array('id', 'policy_name'), "policy");
	foreach ($policies_array as $k => $v) {
		$policy_select .= $v['id']."=".$v['policy_name'].":";
	}
	$edit_account_form->add_element("policy_id", "select", "monoselect|$policy_select", 1);
	$edit_account_form->set_display_name("policy_id", "Scan policy");

	// Quota, mail, xmpp
	$edit_account_form->add_element("quota_kb", "text", "integer|127");
	$edit_account_form->set_display_name("quota_kb", "Quota");
	$edit_account_form->add_input_desc("quota_kb", " MB");

	$edit_account_form->add_element("mail", "checkbox", "bool");
	$edit_account_form->set_display_name("mail", "Email");

	$edit_account_form->add_element("xmpp", "checkbox", "bool");
	$edit_account_form->set_display_name("xmpp", "XMPP");

	// Admin of domains
	if (is_array($_SESSION['login']['admin_of'])) {
		$user_admin_of_ids = explode(",", $content['account_details']['details']['admin_of_ids']);
		if (am_i_server_admin(2)) { // Show all domains
			$all_domains = $cnx->select("id, name", "virtual_domains");
			foreach ($all_domains as $k => $v) {
				$admin_domain_select .= $v['id']."=".$v['name'].":";
			}
		} else { // Show only domains we can admin
			// Fix $content['account_details']['details']['admin_of_ids'] so it only contains IDs we can admin here
			unset($content['account_details']['details']['admin_of_ids']);
			unset($content['account_details']['details']['admin_of_names']);

			foreach ($_SESSION['login']['admin_of'] as $k => $v) {
				if (in_array($k, $user_admin_of_ids)) {
					$content['account_details']['details']['admin_of_ids'] .= "$k,";
					$content['account_details']['details']['admin_of_names'] .= "$v, ";
				}
				$admin_domain_select .= "$k=$v:";
			}
		}
		$edit_account_form->add_element("admin_of_ids", "checkbox", "multiselect|$admin_domain_select");
		$edit_account_form->set_display_name("admin_of_ids", "Administer");
	}

	// Server admin
	$edit_account_form->add_element("admin", "checkbox", "bool");
	$edit_account_form->set_display_name("admin", "Server admin");

	// Suspend
	$edit_account_form->add_element("suspend", "checkbox", "bool");
	$edit_account_form->set_display_name("suspend", "Suspend");


	// Set fields to "display only" before POST
	if (!am_i_admin_of($domain_id) OR (!am_i_server_admin() AND $content['account_details']['details']['admin']) ) {
		$edit_account_form->set_display_only("user");
		$edit_account_form->set_display_only("quota_kb");
		$edit_account_form->set_display_only("mail");
		$edit_account_form->set_display_only("xmpp");
		$edit_account_form->set_display_only("suspend");
	}
	if (!am_i_server_admin()) {
		$edit_account_form->set_display_only("admin");
	}

	// POST
	if ($_POST['edit_account']) {

		// Clean out admin_of_ids before post
		if (is_array($_POST['admin_of_ids'])) {
			foreach ($_POST['admin_of_ids'] as $kk => $x) {
				if (array_key_exists($x, $_SESSION['login']['admin_of']) OR in_array($x, $user_admin_of_ids)) {
					$admin_of_ids2[$x] = $x;
				}
			}
			$_POST['admin_of_ids'] = $admin_of_ids2;
		}

		$edit_account_form->check_post($_POST);
		if (!$edit_account_form->errors()) {

			$edit_array = $edit_account_form->get_values();
			// Clean out edit_array

			// Remove id
			$user_id = $edit_array['id'];
			unset($edit_array['id']);

			// Set proper admin_of IDs - a bit dirty but it works
			$admin_of_array = explode(":", $edit_array['admin_of_ids']);
			if (is_array($admin_of_array)) {
				foreach ($_SESSION['login']['admin_of'] as $domid => $domname) {
					if (in_array($domid, $admin_of_array)) {
						$cnx->insert(array('user_id' => $user_id, 'domain_id' => $domid), "domain_admin_assoc");
					} else {
						// delete
						$cnx->query("DELETE FROM `domain_admin_assoc` WHERE `user_id` ='$user_id' AND `domain_id` ='$domid';", 0);
					}
				}
			}
			unset($edit_array['admin_of_ids']);

			if (!empty($edit_array['password'])) {
				// Fix password
				$edit_array['password'] = crypt_password($edit_array['password']);
			} else {
				unset($edit_array['password']);
			}

			// Fix quota - only if admin of this domain
			if (am_i_admin_of($domain_id) AND strlen($edit_array['quota_kb'])) {
				$edit_array['quota_kb'] = $edit_array['quota_kb'] * 1024;
			}

			// Update !
			$q = $cnx->update($edit_array, "virtual_users", $user_id);
			if ($q) {
				$content['status'][] = "User updated";
				$edit_account_form->set_value("password", "");
			} else {
				$content['errors'][] = "Error while trying to update database";
				$content['errors'][] = $q;
			}
		} else {
			$content['errors'][] = "Form contains errors";
			// unset password
			$edit_account_form->set_value("password", "");
		}
	} else {
		// set default values
		$edit_account_form->set_value("user", $content['account_details']['details']['user']);
		$edit_account_form->set_value_and_validate("policy_id", $content['account_details']['details']['policy_id']);
		$edit_account_form->set_value("quota_kb", ($content['account_details']['details']['quota_kb'] / 1024));
		if (is_array($_SESSION['login']['admin_of'])) {
			$edit_account_form->set_value_and_validate("admin_of_ids", str_replace(",", ":", $content['account_details']['details']['admin_of_ids']));
		}
		if (am_i_admin_of($domain_id)) {
			$edit_account_form->set_value_and_validate("mail", $content['account_details']['details']['mail']);
			$edit_account_form->set_value_and_validate("xmpp", $content['account_details']['details']['xmpp']);
			$edit_account_form->set_value_and_validate("suspend", $content['account_details']['details']['suspend']);
		}
		if (am_i_server_admin()) {
			$edit_account_form->set_value_and_validate("admin", $content['account_details']['details']['admin']);
		}
	}

	// Set values for ALL display_only settings BEFORE outputting form
	if (!am_i_admin_of($domain_id) OR (!am_i_server_admin() AND $content['account_details']['details']['admin'])) {
		$edit_account_form->set_value("user", $content['account_details']['details']['user']);
		$edit_account_form->set_value("quota_kb", ($content['account_details']['details']['quota_kb'] / 1024));
		$edit_account_form->set_value("mail", $content['account_details']['details']['mail']);
		$edit_account_form->set_value("xmpp", $content['account_details']['details']['xmpp']);
		$edit_account_form->set_value("suspend", $content['account_details']['details']['suspend']);
	}
	if (!am_i_server_admin()) {
		$edit_account_form->set_value("admin", $content['account_details']['details']['admin']);
	}

	// Resulting form
	$content['account_details']['forms']['edit_account_form'] = $edit_account_form->result();


} elseif ($alias_id) {

	// Display details
	$content['account_details']['details'] = $cnx->select_row("*", "virtual_aliases", "WHERE `id` = '$alias_id'");
	$content['account_details']['details']['domain'] = $cnx->select_field("name", "virtual_domains", "WHERE `id` = '$domain_id'");

	$edit_alias_form = new FormMaker("edit_alias", genlink("page=account_details|alias_id=$alias_id"));

	if (am_i_admin_of($domain_id)) {
		// User
		$edit_alias_form->add_element("source", "text", "free|127", 1);
		$edit_alias_form->set_display_name("source", "Alias");

		$edit_alias_form->add_element("id", "hidden", "custom|#^$alias_id$#", 1);
		$edit_alias_form->set_value("id", $alias_id);

		$edit_alias_form->add_element("destination", "text", "free|127", 1);
		$edit_alias_form->set_display_name("destination", "Destination email");

		// POST
		if ($_POST['edit_alias']) {
			$edit_alias_form->check_post($_POST);
			if (!$edit_alias_form->errors()) {
				$edit_array = $edit_alias_form->get_values();
				$q = $cnx->update($edit_array, "virtual_aliases", $alias_id);
				if ($q) {
					$content['status'][] = "Alias updated";
				}
			} else {
				$content['errors'][] = "The form contains errors";
			}
		} else {
			$edit_alias_form->set_value_and_validate("source", $content['account_details']['details']['source']);
			$edit_alias_form->set_value_and_validate("destination", $content['account_details']['details']['destination']);
		}
	}

	// Resulting form
	$content['account_details']['forms']['edit_alias_form'] = $edit_alias_form->result();

} elseif ($ml_id) {
	// Display ML details
	$content['account_details']['details'] = $cnx->select_row("*", "virtual_mailing_lists", "WHERE `id` = '$ml_id'");
	$content['account_details']['details']['domain'] = $cnx->select_field("name", "virtual_domains", "WHERE `id` = '$domain_id'");

	$edit_ml_form = new FormMaker("edit_ml", genlink("page=account_details|ml_id=$ml_id"));

	// TODO FIXME - do this ? This should probably be implemented only if the required commands could be executed
	if (am_i_admin_of($domain_id)) {
		// User
		$edit_ml_form->add_element("source", "text", "free|127", 1);
		$edit_ml_form->set_display_name("source", "Alias");

		$edit_ml_form->add_element("id", "hidden", "custom|#^$alias_id$#", 1);
		$edit_ml_form->set_value("id", $alias_id);

		$edit_ml_form->add_element("destination", "text", "free|127", 1);
		$edit_ml_form->set_display_name("destination", "Destination email");

		// POST
		if ($_POST['edit_ml']) {
			$edit_ml_form->check_post($_POST);
			if (!$edit_ml_form->errors()) {
				$edit_array = $edit_ml_form->get_values();
				$q = $cnx->update($edit_array, "virtual_mailing_lists", $alias_id);
				if ($q) {
					$content['status'][] = "ML updated";
				}
			} else {
				$content['errors'][] = "The form contains errors";
			}
		} else {
			$edit_ml_form->set_value_and_validate("source", $content['account_details']['details']['source']);
			$edit_ml_form->set_value_and_validate("destination", $content['account_details']['details']['destination']);
		}
	}

	// Resulting form
	$content['account_details']['forms']['edit_ml_form'] = $edit_ml_form->result();

	//$content['account_details']['details']['ml']['name'] = "ddd";

	// Generate copy pastable config files for this ML

}
?>
