<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/


// Login FORM
$login_form = new FormMaker("login");

$login_form->add_element("username", "text", "free|64", 1);
$login_form->add_element("password", "password", "free|64", 1);

$login_form->set_display_name("username", "Email");
$login_form->set_display_name("password", "Password");


// Deal with POST
if ($_POST['login']) {

	$login_form->check_post($_POST);

	if (!$login_form->errors()) {
		// We have teh data we need,  log in, set session, etc.

		$form_result = $login_form->get_values();

		// Fix username if needed - append server name - FIXME this can break domain names with more than 2 levels
		if (!preg_match("#@#", $form_result['username'])) {
			$domain_name_ar = explode(".", $_SERVER['SERVER_NAME']);
			krsort($domain_name_ar);
			foreach ($domain_name_ar as $k) {
				if ($c < 2) {
					$http_domain = "$k.$http_domain";
				}
				$c++;
			}
			$http_domain = rtrim($http_domain, ".");
			$form_result['username'] .= "@".$http_domain;

		}

		$username = $cnx->escape($form_result['username']);
		$password = $cnx->escape($form_result['password']);

		// Use IMAP/Dovecot to authenticate !!!
		/*
		$mbox = imap_open("{localhost:993/imap/ssl/novalidate-cert}INBOX", $username, $password, NULL, 1);
		if ($mbox) {
			$data = $cnx->select_row("*", "view_users", "WHERE `email` = '$username';");
			imap_close($mbox);
		}*/

		// Use database to authenticate
		$data = $cnx->select_row("*", "view_users", "WHERE `email` = '$username';");
		preg_match('#{(.*)}(.*)#',$data['password'], $password_data); // Thanks konrados

		// Retro compatible - if password is good, convert to ne scheme
		if ($password_data[1] == "PLAIN-MD5") {
			if (md5($password) == $password_data[2]) {
				// Set success var
				$logged_in = 1;
				$q = $cnx->update(array('password' => crypt_password($password)), "virtual_users", $data['uid']);
			}
		} else {
			// Both password_verify AND hash_equals work with SHA512/256, anything salted....
			if (password_verify($password, $password_data[2])) {
			//if (hash_equals($password_data[2], crypt($password, $password_data[2]))) {
				$logged_in = 1;
			}
		}


		if (isset($logged_in) AND is_array($data)) {
			// Set Session
			$_SESSION['login']['uid'] = $data['uid'];
			$_SESSION['login']['domain_id'] = $data['domain_id'];
			$_SESSION['login']['user'] = $data['user'];
			$_SESSION['login']['email'] = $data['email'];
			$_SESSION['login']['domain'] = $data['domain'];

			if ($data['admin']) {
				$_SESSION['login']['admin'] = 1;
				$domains_q = $cnx->select("id, name", "virtual_domains");
				foreach ($domains_q as $k => $v) {
					$id = $v['id'];
					$_SESSION['login']['admin_of'][$id] = $v['name'];
				}

			} else if ($data['admin_of_ids']) {
				$admin_of_ids = explode(",", $data['admin_of_ids']);
				$admin_of_names = explode(",", $data['admin_of_names']);
				$_SESSION['login']['admin_of'] = array_combine($admin_of_ids, $admin_of_names);
			}

			// Set status message
			//$content['status'][] = "$username logged in";
			$link = genlink("page=account_details");
			header("Location: $link");

		} else {
			// Login ERROR
			$content['errors'][] = "Incorrect Email and/or password";
		}

	} else {
		$content['errors'][] = "The form contains errors";
	}
}
// unset password within form
$login_form->set_value("password", "");

$content['login']['form'] = $login_form->result();

?>
