<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/


// New add domain form
if (am_i_server_admin(2)) {
	$add_domain_form = new FormMaker("new_relay_domain");
	$add_domain_form->add_element("domain", "text", "custom|$reg_domain", 1);
	$add_domain_form->set_display_name("domain", "New domain");
	$add_domain_form->add_element("note", "textarea", "free");
	$add_domain_form->set_display_name("note", "Note");
	// Do post
	if ($_POST['new_relay_domain']) {
		$add_domain_form->check_post($_POST);
		if (!$add_domain_form->errors()) {
			$add_domain_vars = $add_domain_form->get_values();
			// Add domain
			$r = $cnx->insert($add_domain_vars, "relay_domains");
			if (is_valid_id($r)) {
				// Reset form
				$add_domain_form->set_value("domain", "");
				$add_domain_form->set_value("note", "");
				$content['status'][] = "Relay domain <strong>".$add_domain_vars['domain']."</strong> added";
			} else {
				$content['errors'][] = $r;
			}
		} else {
			$content['errors'][] = 'Domain name contains errors1!!';
		}
	}
	// Result
	$content['relay_domains']['forms']['add_domain_form'] = $add_domain_form->result();
}

if (am_i_server_admin(4) AND is_valid_id($_GET['edit'])) {
	$edit_ar = $cnx->select_row("*", "relay_domains", "WHERE `id` = ".$_GET['edit']."");
	if ($edit_ar['id'] == $_GET['edit']) {
		$edit_domain_form = new FormMaker("edit_relay_domain", genlink("page=relay_domains|edit=".$edit_ar['id'].""));
		$edit_domain_form->add_element("domain", "text", "custom|$reg_domain", 1);
		$edit_domain_form->set_display_name("domain", "Relay domain");
		$edit_domain_form->add_element("note", "textarea", "free");
		$edit_domain_form->set_display_name("note", "Note");
		// Do post
		if ($_POST['edit_relay_domain']) {
			$edit_domain_form->check_post($_POST);
			if (!$edit_domain_form->errors()) {
				// Add domain
				$edit_domain_vars = $edit_domain_form->get_values();
				$r = $cnx->update($edit_domain_vars, "relay_domains", $edit_ar['id']);
				if (is_valid_id($r)) {
					$content['status'][] = "Relay domain <strong>".$edit_domain_vars['domain']."</strong> updated";
				} else {
					$content['errors'][] = $r;
				}
			} else {
				$content['errors'][] = 'Form contains errors';
			}
		} else {
			// Set form values
			$edit_domain_form->set_value("domain", $edit_ar['domain']);
			$edit_domain_form->set_value("note", $edit_ar['note']);
		}
		// Result
		$content['relay_domains']['forms']['edit_domain_form'] = $edit_domain_form->result();
	}
}

// Delete domain stuffs
if (am_i_server_admin(4) AND is_valid_id($_GET['delete'])) {
	$del_ar = $cnx->select_row("id,domain", "relay_domains", "WHERE `id` = ".$_GET['delete']."");
	if ($del_ar['id'] == $_GET['delete']) {
		if ($_GET['confirm']) {
			//delete
			$q = $cnx->delete($del_ar['id'], "relay_domains", "id");
			if (is_valid_id($q)) {
				$content['status'][] = "Relay domain <strong>".$del_ar['domain']."</strong> deleted";
			} else {
				$content['errors'][] = "Error deleting relay domain from database";
				$content['errors'][] = $q;
			}
		} else {
			$content['relay_domains']['confirm_delete']['domain'] = $del_ar['domain'];
			$content['relay_domains']['confirm_delete']['confirm_link'] = genlink("page=relay_domains|delete=".$_GET['delete']."|confirm=1");
			$content['relay_domains']['confirm_delete']['cancel_link'] = genlink("page=relay_domains");
		}
	}
}

// Init domain list
if (am_i_server_admin(1)) {
	$order_stuff = check_order_by('relay_domains');
	$content['relay_domains']['list']['order_by'] = $order_stuff['th'];
	$content['relay_domains']['list']['domains'] = $cnx->select("*", "relay_domains", "WHERE id !=1 ".$order_stuff['order_by']."");
	if (is_array($content['relay_domains']['list']['domains'])) {
		foreach ($content['relay_domains']['list']['domains'] as $k => $v) {
			if (am_i_server_admin(2)) {
				$content['relay_domains']['list']['domains'][$k]['delete_link'] = genlink("page=relay_domains|delete=".$v['id']."");
				$content['relay_domains']['list']['domains'][$k]['details_link'] = genlink("page=relay_domains|edit=".$v['id']."");
			}
		}
	}
}


?>
