<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/
?>


<h2>
	<?php if (am_i_admin_of($content['account_details']['details']['domain_id'])) { ?>
		<a href="<?php echo genlink("page=accounts|domain_id=".$content['account_details']['details']['domain_id'].""); ?>"><?php echo $content['account_details']['details']['domain']; ?></a>
	<?php } else { ?>
		<?php echo $content['account_details']['details']['domain']; ?>
	<?php } ?>
</h2>


<?php // edit account form
if ($content['account_details']['forms']['edit_account_form']) { ?>
	<fieldset>
		<legend>Edit account</legend>
	<?php	$edit_account_form = new FormPrinter($content['account_details']['forms']['edit_account_form']);
		// Configure base css class for input fields
		$edit_account_form->configure_css("input", "input-text");
		$edit_account_form->configure_css("submit", "input-submit");
		// used for "admin_of"
		$edit_account_form->configure_css("checkbox", "table");
		$edit_account_form->configure_css("label", "table");
		// Generate form
		$edit_account_form->auto_generate_form();
		$edit_account_form->insert_html('<div class="clear"></div>');
		$edit_account_form->print_form("Update"); ?>
	</fieldset>
<?php } ?>


<?php // edit alias form ?>
<?php if ($content['account_details']['forms']['edit_alias_form']) { ?>
	<fieldset>
		<legend>Edit alias</legend>
	<?php	$edit_alias_form = new FormPrinter($content['account_details']['forms']['edit_alias_form']);
		// Configure base css class for input fields
		$edit_alias_form->configure_css("input", "input-text");
		$edit_alias_form->configure_css("submit", "input-submit");
		// Generate form
		$edit_alias_form->auto_generate_form();
		$edit_alias_form->print_form("Update"); ?>
	</fieldset>
<?php } ?>

<?php // Show ML infos ?>
<?php if ($content['account_details']['forms']['edit_ml_form']) { ?>


	<?php // simplify details:
	$ml_addr = $content['account_details']['details']['ml']."@".$content['account_details']['details']['domain'];
	$ml_name = $content['account_details']['details']['ml'];
	$ml_domain = $content['account_details']['details']['domain'];
	?>
	<h2><?php echo $ml_addr; ?></h2>

	<h3>Configuration files</h3>
	<p>The following are configuration files that may go in:
	/home/mlmmj/<?php echo $ml_domain; ?>/<?php echo $ml_name; ?>/control/
	</p>

	<ul class="config">
		<li><strong>customheaders</strong>
		<pre><xmp>Reply-To: List Name <<?php echo $ml_addr;?>>
X-Mailing-List: <<?php echo $ml_addr;?>> List Name
X-Loop: <?php echo $ml_addr;?>

List-Id: <<?php echo $ml_addr;?>>
List-Post: <mailto:<?php echo $ml_addr;?>>
List-Help: <mailto:<?php echo $ml_name;?>+help@<?php echo $ml_domain;?>>
List-Subscribe: <mailto:<?php echo $ml_name;?>+subscribe@<?php echo $ml_domain;?>>
List-Unsubscribe: <mailto:<?php echo $ml_name;?>+unsubscribe@<?php echo $ml_domain;?>>
Precedence: list
Resent-Sender: <?php echo $ml_addr;?>

Resent-From: <?php echo $ml_addr;?>
	</xmp></pre>

		<li><strong>delheaders</strong>
		<xmp>User-Agent:
Received:</xmp>
		</li>

		<li><strong>footer</strong>
		<xmp>--
Add your ML signature here</xmp>
		</li>

		<li><strong>moderators</strong>
		<xmp>list of moderators emails</xmp>
		</li>

		<li><strong>noarchive</strong> - empty file - don't keep an archive
		</li>

		<li><strong>prefix</strong>
		<xmp>[List name]</xmp>
		</li>

		<li><strong>submod</strong> - empty file - subscription moderated by owner
		</li>

		<li><strong>subonlypost</strong> - empty file - only the subcribed may post
		</li>

	</ul>

	<p>Check <a href="http://mlmmj.org/docs/tunables/">the manual</a> for more details and options</p>

	<?php /*
	<fieldset>
		<legend>Edit ML</legend>
	<?php	$edit_ml_form = new FormPrinter($content['account_details']['forms']['edit_ml_form']);
		// Configure base css class for input fields
		$edit_ml_form->configure_css("input", "input-text");
		$edit_ml_form->configure_css("submit", "input-submit");
		// Generate form
		$edit_ml_form->auto_generate_form();
		$edit_ml_form->print_form("Update"); ?>
	</fieldset>
	*/ ?>
	<?php //print_array($content['account_details']['details']); ?>

<?php } ?>

