<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/
?>


<?php // Confirm delete ?>
<?php if ($content['sender_acls']['confirm_delete']) { ?>
	<div id="confirm-delete">
		<p>Do you really want to delete
			<?php if ($content['sender_acls']['confirm_delete']['domain']) { ?>
				the sender <strong><?php echo $content['sender_acls']['confirm_delete']['domain']; ?></strong>
			<?php } else if ($content['sender_acls']['confirm_delete']['ip']) { ?>
				the IP <strong><?php echo $content['sender_acls']['confirm_delete']['ip']; ?></strong>
			<?php } ?>
			?
			<a href="<?php echo $content['sender_acls']['confirm_delete']['confirm_link']; ?>">Yes</a>
			<a href="<?php echo $content['sender_acls']['confirm_delete']['cancel_link']; ?>">NO</a>
		</p>
	</div>
<?php } ?>


<?php // Show edit forms if they need to be ?>
<?php if ($content['sender_acls']['forms']['edit_reject_sender']) { ?>
	<fieldset>
		<legend>Edit blacklist/whitelist sender</legend>
		<?php	$reject_sender_form = new FormPrinter($content['sender_acls']['forms']['edit_reject_sender']);
			$reject_sender_form->configure_css("input", "input-text");
			$reject_sender_form->configure_css("submit", "input-submit");
			$reject_sender_form->auto_generate_form();
			$reject_sender_form->insert_html('<div class="clear"></div>');
			$reject_sender_form->print_form("Reject/Allow"); ?>
	</fieldset>

<?php } else if ($content['sender_acls']['forms']['edit_reject_ip']) { ?>
	<fieldset>
		<legend>Edit blacklist/whitelist IP</legend>
		<?php	$reject_ip_form = new FormPrinter($content['sender_acls']['forms']['edit_reject_ip']);
			$reject_ip_form->configure_css("input", "input-text");
			$reject_ip_form->configure_css("submit", "input-submit");
			$reject_ip_form->auto_generate_form();
			$reject_ip_form->insert_html('<div class="clear"></div>');
			$reject_ip_form->print_form("Reject/Allow"); ?>
	</fieldset>

<?php // Show add forms if they are being edited (contain errors) ?>
<?php } else if ($content['sender_acls']['forms']['add_reject_sender'] AND $content['sender_acls']['forms']['add_reject_sender']['errors']) { ?>
		<fieldset>
			<legend>Add sender to Blacklist/whitelist</legend>
			<?php	$reject_sender_form = new FormPrinter($content['sender_acls']['forms']['add_reject_sender']);
				$reject_sender_form->configure_css("input", "input-text");
				$reject_sender_form->configure_css("submit", "input-submit");
				$reject_sender_form->auto_generate_form();
				$reject_sender_form->insert_html('<div class="clear"></div>');
				$reject_sender_form->print_form("Reject/Allow"); ?>
		</fieldset>

<?php } else if ($content['sender_acls']['forms']['add_reject_ip'] AND $content['sender_acls']['forms']['add_reject_ip']['errors']) { ?>
		<fieldset>
			<legend>Add IP to blacklist/whitelist</legend>
			<?php	$reject_ip_form = new FormPrinter($content['sender_acls']['forms']['add_reject_ip']);
				$reject_ip_form->configure_css("input", "input-text");
				$reject_ip_form->configure_css("submit", "input-submit");
				$reject_ip_form->auto_generate_form();
				$reject_ip_form->insert_html('<div class="clear"></div>');
				$reject_ip_form->print_form("Reject/Allow"); ?>
		</fieldset>
<?php } ?>


<?php // List domain/email based ACL ?>
<?php if (is_array($content['sender_acls']['list']['domains']['domains'])) { ?>
<div class="table" id="domain_list">
	<div class="table-row">
		<div class="table-cell table-th"><a href="<?php echo $content['sender_acls']['list']['domains']['order_by']['domain']; ?>#domain_list">Domain</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['sender_acls']['list']['domains']['order_by']['state']; ?>#domain_list">Status</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['sender_acls']['list']['domains']['order_by']['note']; ?>#domain_list">Note</a></div>
		<div class="table-cell table-th">Delete</div>
	</div>
	<?php foreach ($content['sender_acls']['list']['domains']['domains'] as $k => $v) { ?>
		<div class="table-row">
			<div class="table-cell title">
				<?php if ($v['details_link']) { ?>
				<a href="<?php echo $v['details_link']; ?>"><?php echo $v['domain']; ?></a>
				<?php } else { ?>
				<?php echo $v['domain']; ?>
				<?php } ?>
			</div>
			<div class="table-cell"><span class="hidden">State</span><span><?php echo $v['state']; ?></span></div>
			<div class="table-cell"><span class="hidden">Note</span><span><?php echo $v['note']; ?></span></div>
			<div class="table-cell delete">
			<?php if ($v['delete_link']) { ?>
				<a href="<?php echo $v['delete_link']; ?>">delete</a>
			<?php } ?>
			</div>
		</div>
	<?php } ?>
</div>
<?php } ?>


<?php // List IP based ACL ?>
<?php if (is_array($content['sender_acls']['list']['ips']['ips'])) { ?>
<div class="table" id="iplist">
	<div class="table-row">
		<div class="table-cell table-th"><a href="<?php echo $content['sender_acls']['list']['ips']['order_by']['ip']; ?>#iplist">IP</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['sender_acls']['list']['ips']['order_by']['state']; ?>#iplist">Status</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['sender_acls']['list']['ips']['order_by']['note']; ?>#iplist">Note</a></div>
		<div class="table-cell table-th">Delete</div>
	</div>
	<?php foreach ($content['sender_acls']['list']['ips']['ips'] as $k => $v) { ?>
		<div class="table-row">
			<div class="table-cell title">
				<?php if ($v['details_link']) { ?>
				<a href="<?php echo $v['details_link']; ?>"><?php echo $v['ip']; ?></a>
				<?php } else { ?>
				<?php echo $v['ip']; ?>
				<?php } ?>
			</div>

			<div class="table-cell"><span class="hidden">State</span><span><?php echo $v['state']; ?></span></div>
			<div class="table-cell"><span class="hidden">Note</span><span><?php echo $v['note']; ?></span></div>
			<div class="table-cell delete">
			<?php if ($v['delete_link']) { ?>
				<a href="<?php echo $v['delete_link']; ?>">delete</a>
			<?php } ?>
			</div>
		</div>
	<?php } ?>
</div>
<?php } ?>



<?php // Add reject sender form ?>
<?php if ($content['sender_acls']['forms']['add_reject_sender'] AND !$content['sender_acls']['forms']['add_reject_sender']['errors']) { ?>
		<fieldset>
			<legend>Add sender to Blacklist/whitelist</legend>
			<?php	$reject_sender_form = new FormPrinter($content['sender_acls']['forms']['add_reject_sender']);
				$reject_sender_form->configure_css("input", "input-text");
				$reject_sender_form->configure_css("submit", "input-submit");
				$reject_sender_form->auto_generate_form();
				$reject_sender_form->insert_html('<div class="clear"></div>');
				$reject_sender_form->print_form("Reject/Allow"); ?>
		</fieldset>
<?php } ?>

<?php // Add reject IP form ?>
<?php if ($content['sender_acls']['forms']['add_reject_ip'] AND !$content['sender_acls']['forms']['add_reject_ip']['errors']) { ?>
		<fieldset>
			<legend>Add IP to blacklist/whitelist</legend>
			<?php	$reject_ip_form = new FormPrinter($content['sender_acls']['forms']['add_reject_ip']);
				$reject_ip_form->configure_css("input", "input-text");
				$reject_ip_form->configure_css("submit", "input-submit");
				$reject_ip_form->auto_generate_form();
				$reject_ip_form->insert_html('<div class="clear"></div>');
				$reject_ip_form->print_form("Reject/Allow"); ?>
		</fieldset>
<?php } ?>
