<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/
?>

<h2><?php echo $content['accounts']['details']['domain']['name']; ?></h2>


<?php // Delete account/alias confirmation ?>
<?php if ($content['accounts']['confirm_delete']['user']) { ?>
	<div id="confirm-delete">
		<p>Do you really want to delete the user <strong><?php echo $content['accounts']['confirm_delete']['user']; ?></strong> ?
			<a href="<?php echo $content['accounts']['confirm_delete']['confirm_link']; ?>">Yes</a>
			<a href="<?php echo $content['accounts']['confirm_delete']['cancel_link']; ?>">No</a>
		</p>
	</div>

<?php } else if ($content['accounts']['confirm_delete']['alias']) { ?>
	<div id="confirm-delete">
		<p>Do you really want to delete the alias <strong><?php echo $content['accounts']['confirm_delete']['alias']; ?></strong> ?
			<a href="<?php echo $content['accounts']['confirm_delete']['confirm_link']; ?>">Yes</a>
			<a href="<?php echo $content['accounts']['confirm_delete']['cancel_link']; ?>">No</a>
		</p>
	</div>
<?php } ?>


<?php // Edit domain form
if ($content['accounts']['forms']['edit_domain_form'] AND $content['accounts']['forms']['edit_domain_form']['errors']) { ?>
	<fieldset>
		<legend>Edit domain</legend>
	<?php	$edit_domain_form = new FormPrinter($content['accounts']['forms']['edit_domain_form']);
		// Configure base css class for input fields
		$edit_domain_form->configure_css("input", "input-text");
		$edit_domain_form->configure_css("submit", "input-submit");
		// Generate form
		$edit_domain_form->auto_generate_form();
		$edit_domain_form->print_form("Edit domain"); ?>
	</fieldset>
<?php } ?>


<?php // Add account form
if ($content['accounts']['forms']['add_account_form'] AND $content['accounts']['forms']['add_account_form']['errors']) { ?>
	<fieldset>
		<legend>Add account</legend>
	<?php	$add_account_form = new FormPrinter($content['accounts']['forms']['add_account_form']);
		// Configure base css class for input fields
		$add_account_form->configure_css("input", "input-text");
		$add_account_form->configure_css("submit", "input-submit");
		// used for "admin_of"
		$add_account_form->configure_css("checkbox", "table");
		$add_account_form->configure_css("label", "table");
		// Generate form
		$add_account_form->auto_generate_form();
		$add_account_form->print_form("Add account"); ?>
	</fieldset>
<?php } ?>


<?php // Add alias form
if ($content['accounts']['forms']['add_alias_form'] AND $content['accounts']['forms']['add_alias_form']['errors']) { ?>
	<fieldset>
		<legend>Add alias</legend>
	<?php	$add_alias_form = new FormPrinter($content['accounts']['forms']['add_alias_form']);
		// Configure base css class for input fields
		$add_alias_form->configure_css("input", "input-text");
		$add_alias_form->configure_css("submit", "input-submit");
		// Generate form
		$add_alias_form->auto_generate_form();
		$add_alias_form->print_form("Add alias"); ?>
	</fieldset>
<?php } ?>

<?php // Add ml form
if ($content['accounts']['forms']['add_ml_form'] AND $content['accounts']['forms']['add_ml_form']['errors']) { ?>
	<fieldset>
		<legend>Add ML</legend>
	<?php	$add_ml_form = new FormPrinter($content['accounts']['forms']['add_ml_form']);
		// Configure base css class for input fields
		$add_ml_form->configure_css("input", "input-text");
		$add_ml_form->configure_css("submit", "input-submit");
		// Generate form
		$add_ml_form->auto_generate_form();
		$add_ml_form->print_form("Add ML"); ?>
	</fieldset>
<?php } ?>


<?php // List accounts ?>
<?php if ($content['accounts']['list']['accounts']['users']) { ?>
<h3>Accounts at <?php echo $content['accounts']['details']['domain']['name']; ?></h3>
<div class="table" id="accounts-list">
	<div class="table-row">
		<div class="table-cell table-th"><a href="<?php echo $content['accounts']['list']['accounts']['order_by']['user']; ?>#accounts-list">User</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['accounts']['list']['accounts']['order_by']['quota_kb']; ?>#accounts-list">Quota (MB)</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['accounts']['list']['accounts']['order_by']['mail']; ?>#accounts-list">Email</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['accounts']['list']['accounts']['order_by']['xmpp']; ?>#accounts-list">XMPP</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['accounts']['list']['accounts']['order_by']['policy_name']; ?>#accounts-list">Scan policy</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['accounts']['list']['accounts']['order_by']['admin']; ?>#accounts-list">Admin</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['accounts']['list']['accounts']['order_by']['suspend']; ?>#accounts-list">Suspended</a></div>
		<div class="table-cell table-th">Delete</div>
	</div>
	<?php foreach ($content['accounts']['list']['accounts']['users'] as $k => $v) { ?>
		<div class="table-row">
			<div class="table-cell title">
				<?php if ($v['details_link']) { ?>
				<a href="<?php echo $v['details_link']; ?>"><?php echo $v['user']; ?></a>
				<?php } else { ?>
				<?php echo $v['user']; ?>
				<?php } ?>
			</div>
			<div class="table-cell"><span class="hidden">Quota (MB)</span><span><?php echo ($v['quota_kb'] / 1024); ?></span></div>
			<div class="table-cell"><span class="hidden">Email</span><span><?php echo $v['mail']; ?></span></div>
			<div class="table-cell"><span class="hidden">XMPP</span><span><?php echo $v['xmpp']; ?></span></div>
			<div class="table-cell"><span class="hidden">Scan policy</span><span><?php echo $v['policy_name']; ?></span></div>
			<div class="table-cell"><span class="hidden">Server admin</span><span><?php echo $v['admin']; ?></span></div>
			<div class="table-cell"><span class="hidden">Suspended</span><span><?php echo $v['suspend']; ?></span></div>
			<div class="table-cell delete">
			<?php if ($v['delete_link']) { ?>
				<a href="<?php echo $v['delete_link']; ?>">delete</a>
			<?php } ?>
			</div>
		</div>
	<?php } ?>
</div>
<?php } ?>


<?php // List aliases ?>
<?php if ($content['accounts']['list']['aliases']['users']) { ?>
<h3>Aliases at <?php echo $content['accounts']['details']['domain']['name']; ?></h3>
<div class="table" id="alias-list">
	<div class="table-row">
		<div class="table-cell table-th"><a href="<?php echo $content['accounts']['list']['aliases']['order_by']['source']; ?>#alias-list">Source</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['accounts']['list']['aliases']['order_by']['destination']; ?>#alias-list">Destination</a></div>
		<div class="table-cell table-th">Delete</div>
	</div>
	<?php foreach ($content['accounts']['list']['aliases']['users'] as $k => $v) { ?>
		<div class="table-row">
			<div class="table-cell title">
				<?php if ($v['details_link']) { ?>
				<a href="<?php echo $v['details_link']; ?>"><?php echo $v['source']; ?>@<?php echo $content['accounts']['details']['domain']['name']; ?></a>
				<?php } else { ?>
				<?php echo $v['source']; ?>@<?php echo $content['accounts']['details']['domain']['name']; ?>
				<?php } ?>
			</div>
			<div class="table-cell"><span class="hidden">Destination</span><span><?php echo $v['destination']; ?></span></div>
			<div class="table-cell delete">
			<?php if ($v['delete_link']) { ?>
				<a href="<?php echo $v['delete_link']; ?>">delete</a>
			<?php } ?>
			</div>
		</div>
	<?php } ?>
</div>
<?php } ?>

<?php // List MLs ?>
<?php if ($content['accounts']['list']['ml']['lists']) { ?>
<h3>Mailing lists</h3>
<div class="table" id="ml-list">
	<div class="table-row">
		<div class="table-cell table-th"><a href="<?php echo $content['accounts']['list']['ml']['order_by']['source']; ?>#ml-list">List</a></div>
		<div class="table-cell table-th">Delete</div>
	</div>
	<?php foreach ($content['accounts']['list']['ml']['lists'] as $k => $v) { ?>
		<div class="table-row">
			<div class="table-cell title">
				<?php if ($v['details_link']) { ?>
				<a href="<?php echo $v['details_link']; ?>"><?php echo $v['ml']; ?>@<?php echo $content['accounts']['details']['domain']['name']; ?></a>
				<?php } else { ?>
				<?php echo $v['ml']; ?>@<?php echo $content['accounts']['details']['domain']['name']; ?>
				<?php } ?>
			</div>
			<div class="table-cell delete">
			<?php if ($v['delete_link']) { ?>
				<a href="<?php echo $v['delete_link']; ?>">delete</a>
			<?php } ?>
			</div>
		</div>
	<?php } ?>
</div>
<?php } ?>


<?php // Edit domain form
if ($content['accounts']['forms']['edit_domain_form'] AND !$content['accounts']['forms']['edit_domain_form']['errors']) { ?>
	<fieldset>
		<legend>Edit domain</legend>
	<?php	$edit_domain_form = new FormPrinter($content['accounts']['forms']['edit_domain_form']);
		// Configure base css class for input fields
		$edit_domain_form->configure_css("input", "input-text");
		$edit_domain_form->configure_css("submit", "input-submit");
		// Generate form
		$edit_domain_form->auto_generate_form();
		$edit_domain_form->print_form("Edit domain"); ?>
	</fieldset>
<?php } ?>


<?php // Add account form
if ($content['accounts']['forms']['add_account_form'] AND !$content['accounts']['forms']['add_account_form']['errors']) { ?>
	<fieldset>
		<legend>Add account</legend>
	<?php	$add_account_form = new FormPrinter($content['accounts']['forms']['add_account_form']);
		// Configure base css class for input fields
		$add_account_form->configure_css("input", "input-text");
		$add_account_form->configure_css("submit", "input-submit");
		// used for "admin_of"
		$add_account_form->configure_css("checkbox", "table");
		$add_account_form->configure_css("label", "table");
		// Generate form
		$add_account_form->auto_generate_form();
		$add_account_form->print_form("Add account"); ?>
	</fieldset>
<?php } ?>


<?php // Add alias form
if ($content['accounts']['forms']['add_alias_form'] AND !$content['accounts']['forms']['add_alias_form']['errors']) { ?>
	<fieldset>
		<legend>Add alias</legend>
	<?php	$add_alias_form = new FormPrinter($content['accounts']['forms']['add_alias_form']);
		// Configure base css class for input fields
		$add_alias_form->configure_css("input", "input-text");
		$add_alias_form->configure_css("submit", "input-submit");
		// Generate form
		$add_alias_form->auto_generate_form();
		$add_alias_form->print_form("Add alias"); ?>
	</fieldset>
<?php } ?>


<?php // Add ml form
if ($content['accounts']['forms']['add_ml_form'] AND !$content['accounts']['forms']['add_ml_form']['errors']) { ?>
	<fieldset>
		<legend>Add ML</legend>
	<?php	$add_ml_form = new FormPrinter($content['accounts']['forms']['add_ml_form']);
		// Configure base css class for input fields
		$add_ml_form->configure_css("input", "input-text");
		$add_ml_form->configure_css("submit", "input-submit");
		// Generate form
		$add_ml_form->auto_generate_form();
		$add_ml_form->print_form("Add ML"); ?>
	</fieldset>
<?php } ?>
